////////////////////////////////////////////////////////////////////////
// Class:       CheckGeometryT962
// Module Type: analyzer
// File:        CheckGeometryT962_module.cc
//
// Generated at Tue Jan  6 22:27:12 2015 by Tingjun Yang using artmod
// from cetpkgsupport v1_07_00.
////////////////////////////////////////////////////////////////////////
#include "art/Framework/Core/EDAnalyzer.h"
#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"
#include "art/Framework/Principal/Run.h"
#include "art/Framework/Principal/SubRun.h"
#include "art_root_io/TFileService.h" 
#include "canvas/Utilities/InputTag.h"
#include "fhiclcpp/ParameterSet.h"
#include "messagefacility/MessageLogger/MessageLogger.h"
#include "larcore/Geometry/Geometry.h"
#include "lardata/DetectorInfoServices/DetectorPropertiesService.h"
#include "lardata/DetectorInfoServices/DetectorClocksService.h"
#include "TMatrixD.h"

#include <iostream>
#include <vector>

//constexpr unsigned short kMaxAuxDets = 100; // unused
//constexpr unsigned short kMaxTkIDs = 100; // unused

namespace dune {
  class CheckGeometryT962;
}

class dune::CheckGeometryT962 : public art::EDAnalyzer {
public:
  explicit CheckGeometryT962(fhicl::ParameterSet const & p);
  // The destructor generated by the compiler is fine for classes
  // without bare pointers or other resource use.

  // Plugins should not be copied or assigned.
  CheckGeometryT962(CheckGeometryT962 const &) = delete;
  CheckGeometryT962(CheckGeometryT962 &&) = delete;
  CheckGeometryT962 & operator = (CheckGeometryT962 const &) = delete;
  CheckGeometryT962 & operator = (CheckGeometryT962 &&) = delete;

  // Required functions.
  void analyze(art::Event const & e) override;

  // Selected optional functions.
  void reconfigure(fhicl::ParameterSet const & p) ;

private:

  // Declare member data here.

};


dune::CheckGeometryT962::CheckGeometryT962(fhicl::ParameterSet const & p)
  :
  EDAnalyzer(p)
{
  reconfigure(p);
}

void dune::CheckGeometryT962::analyze(art::Event const & evt)
{

  art::ServiceHandle<geo::Geometry> geo;
  auto const clockData = art::ServiceHandle<detinfo::DetectorClocksService const>()->DataFor(evt);

  auto const detProp = art::ServiceHandle<detinfo::DetectorPropertiesService const>()->DataFor(evt, clockData);

  //std::cout<<25<<" "<<detProp.ConvertXToTicks(25,0,0,0)<<" "<<detProp.ConvertXToTicks(25,1,0,0)<<std::endl;
  std::cout<<"working on x -> t"<<std::endl;
  for (int i = 0; i<2; ++i){
    std::cout<<"Plane "<<i<<std::endl;
    double x0 = 10;
    double x1 = 30;
    double t0 = detProp.ConvertXToTicks(x0,i,0,0);
    double t1 = detProp.ConvertXToTicks(x1,i,0,0);
    std::cout<<x0<<" "<<t0<<" "<<x1<<" "<<t1<<std::endl;
    double b = (t1-t0)/(x1-x0);
    double a = t0 - b*x0;
    std::cout<<"a = "<<a<<" b = "<<b<<std::endl;
    std::cout<<20<<" "<<detProp.ConvertXToTicks(20,i,0,0)<<" "<<a+20*b<<std::endl;
  }

  std::cout<<"working on yz-> w"<<std::endl;
  constexpr geo::TPCID tpcID{};
  for (unsigned int i = 0; i<2u; ++i){
    std::cout<<"Plane "<<i<<std::endl;
    geo::PlaneID const planeID{tpcID, i};
    TMatrixD m(3,3);
    TMatrixD w(3,1);
    double const y[3] = {-10, 10, 5};
    double const z[3] = {10, 60, 30};
    for (unsigned int j = 0; j<3u; ++j){
      m(j,0) = y[j];
      m(j,1) = z[j];
      m(j,2) = 1;
      w(j,0) = geo->WireCoordinate(geo::Point_t{0, y[j], z[j]}, planeID);
    }
    TMatrixD p = m.Invert()*w;
    std::cout<<"a = "<<p(0,0)<<" b = "<<p(1,0)<<" c = "<<p(2,0)<<std::endl;
//    double a = (w0*z1-w1*z0)/(y0*z1-y1*z0);
//    double b = (w0*y1-w1*y0)/(z0*y1-z1*y0);
//    std::cout<<"a = "<<a<<" b = "<<b<<std::endl;
    std::cout<<0<<" "<<30<<" "<<geo->WireCoordinate(geo::Point_t{0, 0, 30}, planeID)<<" "<<p(0,0)*0+p(1,0)*30+p(2,0)<<std::endl;
    std::cout<<19<<" "<<5<<" "<<geo->WireCoordinate(geo::Point_t{0, 19, 5}, planeID)<<" "<<p(0,0)*19+p(1,0)*5+p(2,0)<<std::endl;
  }

}

void dune::CheckGeometryT962::reconfigure(fhicl::ParameterSet const & p)
{
  // Implementation of optional member function here.
}

DEFINE_ART_MODULE(dune::CheckGeometryT962)
